<?php

/**
 * co_contrato actions.
 *
 * @package    contratacion
 * @subpackage co_contrato
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
require_once 'HTMLPurifier.auto.php';
require 'HTMLPurifier.autoload.php';

class co_contratoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_CONTRATO_V',
        'CO_CONTRATISTA',
        'CO_SELECCION_EP',
        'CO_INICIO_CONTRATO',
        'CO_CATEGORIA',
        'CO_ESTUDIOS_PREVIOS',
        'CO_MODALIDAD_SEL',
        'CO_LEGALIZA_CONTRATO',
        'RPS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_CONTRATISTA' =>
        array(
            'id_contratista' => 'CO_CONTRATO_V'
        ),
        'CO_SELECCION_EP' =>
        array(
            'id_seleccion_ep' => 'CO_CONTRATO_V'
        ),
        'CO_INICIO_CONTRATO,LEFT' =>
        array(
            'id_inicio_contrato' => 'CO_CONTRATO_V'
        ),
        'CO_CATEGORIA,LEFT' =>
        array(
            'id_categoria' => 'CO_CONTRATO_V'
        ),
        'CO_ESTUDIOS_PREVIOS,LEFT' =>
        array(
            'id_estudios_previos' => 'CO_SELECCION_EP'
        ),
        'CO_MODALIDAD_SEL,LEFT' =>
        array(
            'id_modalidad_sel' => 'CO_ESTUDIOS_PREVIOS'
        ),
        'CO_LEGALIZA_CONTRATO,LEFT' =>
        array(
            'id_contrato' => 'CO_CONTRATO_V'
        ),
        'RPS_V,LEFT' =>
        array(
            'id_rp-id' => 'CO_LEGALIZA_CONTRATO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CONTRATO_V' =>
        array(
            'id_contrato' => 'id_contrato',
            'no_contrato' => 'no_contrato',
            'fecha_contrato' => 'fecha_contrato',
            'id_anhos' => 'id_anhos',
            'id_seleccion_ep' => 'id_seleccion_ep',
            'id_tipo_contrato' => 'id_tipo_contrato',
            'id_contratista' => 'id_contratista',
            'id_categoria' => 'id_categoria',
            'plazo' => 'plazo',
            'objeto' => 'objeto',
            'valor' => 'valor',
            'estado' => 'estado',
            'activo' => 'activo',
            'liquidado' => 'liquidado',
            'adjunto_contrato' => 'adjunto_contrato',
            'adjunto_resolucion' => 'adjunto_resolucion',
            'fecha_anu' => 'fecha_anu',
            'motivo_anu' => 'motivo_anu',
            'id_tipo_convenio' => 'id_tipo_convenio',
            'valor_anticipo' => 'valor_anticipo',
            'porcentaje_anticipo' => 'porcentaje_anticipo',
            'id_inicio_contrato' => 'id_inicio_contrato',
            'terminacion' => 'terminacion',
            'dias_plazo' => 'dias_plazo',
            'meses_plazo' => 'meses_plazo',
            'anhos_plazo' => 'anhos_plazo',
            'liquidacion' => 'liquidacion',
            'meses_liquida' => 'meses_liquida',
            'carta_aceptacion' => 'carta_aceptacion',
            'tipo' => 'tipo',
            'id_ordenador_gasto' => 'ordenador_gasto',
            'id_ordenador_gasto' => 'id_ordenador_gasto',
            'modalidad' => 'modalidad',
            'proceso' => 'proceso',
            'completo_contra' => 'completo_contra',
            'tipo_contrato' => 'tipo_contrato',
            'completo_supervisor' => 'completo_supervisor',
            'completo_ordenador' => 'completo_ordenador',
            'tipo_convenio' => 'tipo_convenio',
            'id_supervisor' => 'id_supervisor',
            'valor_cdp' => 'valor_cdp',
            'valor_cdp,-,valor' => 'valor_ahorro',
            'consideraciones' => 'consideraciones',
            'perfeccionamiento_ejec' => 'perfeccionamiento_ejec',
            'obliga_gen_contratista' => 'obliga_gen_contratista',
            'valor_texto' => 'valor_texto',
            'supervisor' => 'supervisor',
            'fuente_financiamiento' => 'fuente_financiamiento',
            'fecha_secop' => 'fecha_secop',
            'fecha_liquidacion_cont' => 'fecha_liquidacion_cont',
            'valor_mensual' => 'valor_mensual',
            'orden_compra' => 'orden_compra',
            'numero_pago' => 'numero_pago',
            'apoyo_supervisor' => 'apoyo_supervisor',
            'aplica_estampilla' => 'aplica_estampilla',
            'select_estampilla' => 'select_estampilla',
            'select_liquidacion' => 'aplica_liquidacion',
            'contrato' => 'contrato',
            'convenio' => 'convenio',
            'id_benef_estampilla' => 'id_benef_estampilla',
            'valor_primer_pago' => 'valor_primer_pago'
        ),
        'CO_CONTRATISTA' =>
        array(
            'id_tipo_iden' => 'id_tipo_iden',
            'num_doc' => 'num_doc',
            'dv' => 'dv',
            'telefono' => 'telefono',
            'celular' => 'celular',
            'direccion' => 'direccion',
            'email' => 'email',
            'representante_legal' => 'representante_legal',
            'ciudad' => 'ciudad',
            'factor_rh' => 'factor_rh',
            'fecha_nacimiento' => 'fecha_nacimiento',
            'ciudad_nacimiento' => 'ciudad_nacimiento'
        ),
        'CO_SELECCION_EP' =>
        array(
            'id_estudios_previos' => 'id_estudios_previos'
        ),
        'CO_INICIO_CONTRATO' =>
        array(
            'descripcion' => 'ini_contra'
        ),
        'CO_CATEGORIA' =>
        array(
            'descripcion' => 'descripcion',
            'sueldo' => 'sueldo'
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_tipo_proceso' => 'id_tipo_proceso',
            'id_modalidad_sel' => 'id_modalidad_sel'
        ),
        'CO_LEGALIZA_CONTRATO' =>
        array(
            'id_legaliza_contrato' => 'id_legaliza_contrato',
            'id_rp' => 'id_rp',
            'fecha_aprueba_poliza' => 'fecha_aprueba_poliza',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_terminacion' => 'fecha_terminacion',
            'fecha_liquidacion' => 'fecha_liquidacion',
            'adjunto_poliza' => 'adjunto_poliza',
            'adjunto_rp' => 'adjunto_rp'
        ),
        'RPS_V' =>
        array(
            'rp' => 'rp',
            'vigencia' => 'vigencia_rp',
            'fecha' => 'fecha_rp',
            'valor' => 'valor_rp',
            'rp,||, - ,||,vigencia' => 'completo_rp'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'no_contrato', 'proceso', 'tipo'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CONTRATO_V' =>
        array(
            'id_contrato,a' => array('!=' => array(-1)),
            'id_contrato,b' => array('=' => array('id_contrato')),
            'id_anhos' => array('=' => array('id_anhos')),
            'id_seleccion_ep' => array('=' => array('id_seleccion_ep')),
            'id_tipo_contrato' => array('=' => array('id_tipo_contrato')),
            'id_tipo_convenio' => array('=' => array('id_tipo_convenio')),
            'id_supervisor' => array('=' => array('id_supervisor')),
            'fecha_contrato' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'no_contrato' => array('=' => array('no_contrato_null')),
            'no_contrato' => array('=' => array('no_contrato')),
            'id_contratista' => array('=' => array('id_contratista')),
            'estado' => array('=' => array('estado')),
            'activo' => array('=' => array('activo')),
            'liquidado' => array('=' => array('liquidado')),
            'aplica_estampilla' => array('=' => array('aplica_estampilla')),
            'id_categoria' => array('=' => array('id_categoria')),
            'orden_compra' => array('=' => array('orden_compra')),
            //'id_supervisor' => array('=' => array('id_username')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_SELECCION_EP' =>
        array(
            'id_estudios_previos' => array('=' => array('id_estudios_previos'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variacble que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_contrato'; //identificador de la tabla
    protected $id_names = array('id_contrato'); //llave primaria
    protected $field_names = array('no_contrato', 'id_anhos', 'fecha_contrato', 'id_seleccion_ep', 'id_tipo_contrato', 'id_contratista', 'plazo', 'valor',
        'estado', 'activo', 'liquidado', 'adjunto_contrato', 'objeto', 'fecha_anu', 'id_ordenador_gasto', 'id_tipo_convenio', 'valor_anticipo',
        'motivo_anu', 'porcentaje_anticipo', 'id_inicio_contrato', 'terminacion', 'dias_plazo', 'meses_plazo', 'anhos_plazo', 'liquidacion', 'meses_liquida', 'carta_aceptacion',
        'adjunto_resolucion', 'id_categoria', 'consideraciones', 'perfeccionamiento_ejec', 'obliga_gen_contratista', 'valor_texto', 'supervisor', 'fecha_secop', 'fecha_liquidacion_cont',
        'valor_mensual', 'orden_compra', 'numero_pago', 'apoyo_supervisor', 'aplica_estampilla', 'id_benef_estampilla', 'valor_primer_pago'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CONTRATO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_contrato'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //Obtenemos la entidad
        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');
        $int = 0;
        $serviceHtml_url = "";
        $service_url_new = null;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('serviceHtml_url' == $routeName) {
                foreach ($routeData as $key => $value) {
                    if ($key == 'value') {
                        $serviceHtml_url = $value;
                        $this->service_url = $serviceHtml_url;
                    }
                }
            }
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            if ('jasper_url' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $url_jasper = $value;
                    }
                }
            }
            if ('service_url_new' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $service_url_new = $value;
                    }
                }
            }
            $int++;
        }

        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {

                //Actualizacion 03 de Noviembre
                //Si la categoria del contratista es diferente de null 
                //actualizo el sueldo del contrastista en la tabla TERCEROS de comisiones 
                $id_categoria = $list_data_post[0]['id_categoria'];
                $id_contratista = $list_data_post[0]['id_contratista'];

                if ($id_categoria != null || $id_categoria != "null" || $id_categoria != '') {

                    $sql = <<<EOD
select tab0.sueldo

from co_categoria tab0
where tab0.id_categoria = $id_categoria
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    $sueldo = $records[0]['sueldo'];

                    //Valida valor 0 - 20170505
                    if ($sueldo > 0) {
                        $sql = <<<EOD
select tab0.num_doc

from co_contratista tab0
where tab0.id_contratista = $id_contratista
EOD;

                        $records = CN_TABLE::executeSQL($sql);

                        $num_doc = $records[0]['num_doc'];

                        $sql = <<<EOD
update terceros set sueldo = $sueldo where nitocc = $num_doc
EOD;
                        CN_TABLE::executeSQL($sql);
                    }
                }

                $this->conn->commit();

                //ENVIO CORREO 6 - Notificacion de Registro de Contrato
//PARAMETROS GENERALES

                $subject = "Notificacion de Registro de Contrato";
                //Email Envio
                if (!isset($request["email_envio"])) {


                    //Obtenemos la entidad
                    $array = sfYaml::load(dirname(__FILE__) . '/../../../../api/config/app-gwt.yml');
                    $int = 0;
                    foreach ($array as $routeName => $routeData) {
                        //echo $routeName . "\n";
                        if ('correoEnvio' == $routeName) {
                            foreach ($routeData as $key => $value) {
                                //echo $value . "\n";
                                if ($key == 'value') {
                                    $email_envio = $value;
                                }
                            }
                        }
                        $int++;
                    }

                    $request["email_envio"] = $email_envio;
                }
                $adjunto = false;
                $ruta = "";

                /*
                 * Variable Memcache
                 */
                $progress_key = $request['progress_key'] . $request['username'];
                $this->logMessage("Valor de progress_key: " . $progress_key);

                $array_adjuntos = array();


                $sql = "
        SELECT tab0.dia_sistema||' de '||tab0.mes_sistema||' del '||anho_sistema AS FECHA_SISTEMA
           from(
            select LPAD(to_char(sysdate,'dd'),2,'0') as dia_sistema,
            trim(initcap(to_char(sysdate,'MONTH','nls_date_language=spanish'))) as mes_sistema,
            TO_CHAR(sysdate,'yyyy') as anho_sistema
            from dual
        )tab0
        ";

                $records = CN_TABLE::executeSQL($sql);
                $fecha_creacion = $records[0]['fecha_sistema'];



                $id_contrato = $list_data_post[0]['id_contrato'];

                $sql = <<<EOD
select tab0.no_contrato,tab0.id_anhos as vigencia, tab0.valor, tab0.objeto, tab0.tipo, tab0.completo_contra, tab0.completo_supervisor, tab1.id_estudios_previos

from co_contrato_v tab0
join co_seleccion_ep tab1 ON tab1.id_seleccion_ep = tab0.id_seleccion_ep
where tab0.id_contrato = $id_contrato
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $no_contrato = $records[0]['no_contrato'];
                $vigencia = $records[0]['vigencia'];
                $tipo = $records[0]['tipo'];
                $contratista = $records[0]['completo_contra'];
                $supervisor = $records[0]['completo_supervisor'];
                $objeto = $this->htmlClear($records[0]['objeto']);
                $id_estudios_previos = $records[0]['id_estudios_previos'];

                $sql = <<<EOD
select tab0.*,tab1.aplica_proceso AS APLICA_PROCESO
    from co_estudios_previos_v tab0 
    LEFT JOIN co_modalidad_sel tab1 ON tab1.id_modalidad_sel = tab0.id_modalidad_sel 
        where tab0.id_estudios_previos = $id_estudios_previos
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $responsable = $records[0]['nombre_responsable'];
                $area = $records[0]['area'];
                $valor = $records[0]['valor'];
                $valor = number_format($valor);
                $modalidad = $records[0]['modalidad'];
                $abogado = $records[0]['abogado'];
                $proceso = $records[0]['proceso'];
                $aplica_proceso = $records[0]['aplica_proceso'];

                if ($aplica_proceso == 0) {
                    $titulo = "DATOS DEL ESTUDIO PREVIO";
                    $titulo2 = "Estudio Previo No.";
                } else {
                    $titulo = "DATOS DEL PROCESO";
                    $titulo2 = "Proceso No.";
                }



//1. Se realiza Consulta a la tabla de administracion alarmas para saber a quien van dirigidos los correos

                $sql = <<<EOD
select tab2.num_doc, tab2.id_tipo_doc, tab2.razon_soc, nvl(tab3.mail,'mesadeayuda@sgc.gov.co') email, tab4.descripcion as rol
from co_administra_alarma tab0
join co_rol_proceso_v tab1 ON tab1.id_rol = tab0.id_rol and tab1.id_estudios_previos = $id_estudios_previos
join interceros_v tab2 ON tab2.id_mae_ter = tab1.id_mae_ter
join interceros_du_dir_v tab3 ON tab3.id_mae_ter = tab2.id_mae_ter
join co_rol tab4 ON tab4.id_rol = tab0.id_rol                        
where tab0.id_alarma = 6 and tab1.id_mae_ter is not null
EOD;

                $records = CN_TABLE::executeSQL($sql);

                foreach ($records as $correos) {

                    $documento = $correos['num_doc'];
                    $tipo_doc = $correos['id_tipo_doc'];
                    $nombre = $correos['razon_soc'];
                    $email = $correos['email'];
                    $rol = $correos['rol'];

                    $parametros = $documento . ";$tipo_doc;" . $email . ";" . $nombre . ";Envio notificacion";

                    $datos_usuario = array();

                    if ($parametros != "") {
                        $datos_usuario = explode('/', $parametros);
                    }

//CUERPO DEL MENSAJE

                    $body = "<html><body> </body></html>";
//Body
                    $body = <<<EOD
                <html><body> 
                <br/>
                Bogotá, $fecha_creacion
                <br/>
                <br/>
                Señor(a)<br/>
                $nombre<br/>
                $rol
                <br/><br/>
                Por medio de la presente se notifica el <b>Registro de contrato No. $no_contrato de $vigencia</b><br/><br/>
                <b>DATOS DEL CONTRATO:</b><br/>
                <b>Contratista.</b> $contratista<br/><br/>
                <b>Supervisor:</b> $supervisor<br/><br/>
                <b>Tipo de Contrato:</b> $tipo<br/><br/>
                <b>Valor del Contrato:</b> $valor<br/><br/>
                <b>Objeto:</b> $objeto<br/><br/>
                <br></br>
                <b>$titulo</b>
                <br></br>
                <b>$titulo2</b> $proceso<br/><br/>
                <b>Area:</b> $area<br/><br/>
                <b>Responsable:</b> $responsable<br/><br/>
                <b>Abogado:</b> $abogado<br/><br/>
                <br/><br/>
                
                </body></html>
EOD;

                    $currentUri = "";

                    CN_TABLE::envioCorreo($request, $datos_usuario, $subject, $currentUri, $ruta, $adjunto, $progress_key, $array_adjuntos, $body);
                }
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            $cerrar_contrato = $request['cerrar_contrato'];
            $activo = $request['activo'];

            //Actualizar campos HTML - 20210917
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            $id_contrato = $list_data_post[0]['id_contrato'];
            $sql = <<<EOD
update co_contrato 
set objeto = REPLACE(REPLACE(REPLACE(REPLACE(objeto,'amp;',''),chr(38)||'lt;','<'),chr(38)||'gt;','>'),chr(38)||'quot;','"'),
plazo = REPLACE(REPLACE(REPLACE(REPLACE(plazo,'amp;',''),chr(38)||'lt;','<'),chr(38)||'gt;','>'),chr(38)||'quot;','"'), 
consideraciones = REPLACE(REPLACE(REPLACE(REPLACE(consideraciones,'amp;',''),chr(38)||'lt;','<'),chr(38)||'gt;','>'),chr(38)||'quot;','"') 
where id_contrato = $id_contrato
EOD;
            CN_TABLE::executeSQL($sql);
            $this->conn->execute($sql);
            $this->conn->commit();

            $logger->info("Entidad: $entidadCliente - cerrar contrato: $cerrar_contrato - activo: $activo");

            // SI ES ANM CREAMOS NUEVO CONTRATO EN RVC
            //if( $entidadCliente == 2 && $cerrar_contrato == "true" && $activo == "false"){
            if ($cerrar_contrato == "true" && $activo == "false") {

                $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                $this->conn->beginTransaction();
                $id_contrato = $list_data_post[0]['id_contrato'];
                $no_contrato = $list_data_post[0]['no_contrato'];
                $params = array(
                    'comando ' => 'co_pdf_contrato'
                );
                try {
                    if ($entidadCliente == 2) {
                        $url_gen_contrato = $serviceHtml_url . "co_pdf_contrato/pdf?id_contrato=$id_contrato&savefile=true";
                        $params["id_contrato"] = $id_contrato;
                        $params["savefile"] = "true";
                        CN_TABLE::curlPostAsync($url_gen_contrato, $params);
                    }
                    // Confirmamos que el contrato tenga legalizaciones y amparos registrado sehun la entidad
                    if ($entidadCliente == 2) {
                        $consulta_sql = <<<EOD
SELECT tab0.ID_LEGALIZA_CONTRATO
FROM CO_LEGALIZA_CONTRATO tab0
join co_contrato_arl tab2 on tab2.id_contrato = tab0.id_contrato
WHERE 1=1 AND tab0.ID_CONTRATO=$id_contrato
EOD;
                    } else {

                        $consulta_sql = <<<EOD
SELECT tab0.ID_LEGALIZA_CONTRATO
FROM CO_LEGALIZA_CONTRATO tab0
join CO_AMPARO_CONT tab1 on tab1.id_contrato = tab0.id_contrato
join co_contrato_arl tab2 on tab2.id_contrato = tab0.id_contrato
WHERE 1=1 AND tab0.ID_CONTRATO=$id_contrato
EOD;
                    }

                    $records = CN_TABLE::executeSQL($consulta_sql);


                    if (count($records) > 0) {
                        // Validamos que el tipo de contrato este relacionado en RVC si no se omite la creacion del contrato
                        $sql = <<<EOD
Select tab1.id_rvc_tipo_contrato
from co_contrato tab0
join co_tipo_contrato tab1 on tab1.id_tipo_contrato = tab0.id_tipo_contrato
where  ID_CONTRATO=$id_contrato and  id_rvc_tipo_contrato is not null                       
EOD;
                        $records = CN_TABLE::executeSQL($sql);
                        if (count($records) > 0) {
                            //Obtenemos el supervisor
                            $sql = <<<EOD
select tab2.id_supervisor as id_supervisor, nvl(tab4.mail,'correo@correo.com') as mail
from CO_CONTRATO tab0
JOIN CO_SELECCION_EP tab1 on tab1.ID_SELECCION_EP = tab0.ID_SELECCION_EP
JOIN CO_ESTUDIOS_PREVIOS tab2 on tab2.ID_ESTUDIOS_PREVIOS = tab1.ID_ESTUDIOS_PREVIOS
LEFT JOIN INTERCEROS tab3 on tab3.id_mae_ter = tab2.id_supervisor
LEFT JOIN INTERCER_DU tab4 on tab4.id_mae_ter = tab3.ID_MAE_TER
where tab0.id_contrato = $id_contrato
EOD;
                            $records = CN_TABLE::executeSQL($sql);
                            $id_mae_ter = $records[0]['id_supervisor'];
                            $mail_supervisor = $records[0]['mail'];
                            $sql = <<<EOD
select * from RVC_SUPERVISOR WHERE id_mae_ter = $id_mae_ter
EOD;
                            $records = CN_TABLE::executeSQL($sql);
                            if (count($records) > 0) {
                                $id_supervisor = $records[0]['id_supervisor'];
                            } else {
                                $sql = <<<EOD
INSERT INTO RVC_SUPERVISOR(ID_MAE_TER,CARGO,CORREO) VALUES($id_mae_ter,'CREADO AUTOMATICAMENTE DESDE CONTRATACION','$mail_supervisor')
EOD;
                                $this->conn->execute($sql);
                                $sql = <<<EOD
select * from RVC_SUPERVISOR WHERE id_mae_ter = $id_mae_ter
EOD;
                                $records = CN_TABLE::executeSQL($sql);
                                $id_supervisor = $records[0]['id_supervisor'];
                            }
                            if ($entidadCliente == 2) {
                                $condicionNumeroContrato = "case when tab0.fuente_financiamiento = 'NACION' then 'ANM'  || '-'||  case when LENGTH(tab0.no_contrato) < 3 then LPAD(tab0.no_contrato,3,'0') else TO_CHAR(tab0.no_contrato) end ||'-'||tab0.id_anhos else  'SGR'  || '-'|| LPAD(tab0.no_contrato,3,'0') ||'-'||tab0.id_anhos end";
                                $adjuntoContrato = "'contrato_$id_contrato.pdf'";
                                $meses_plazo = "tab0.meses_plazo";
                                $dias_plazo = "tab0.dias_plazo";
                                // $anhos_plazo
                                // $fecha_inicio
                            } else {
                                $condicionNumeroContrato = "case when LENGTH(tab0.no_contrato) < 3 then LPAD(tab0.no_contrato,3,'0') else TO_CHAR(tab0.no_contrato) end ||'-'||tab0.id_anhos";
                                $adjuntoContrato = "tab9.adjunto_contrato";
                                $meses_plazo = "tab9.meses_plazo";
                                $dias_plazo = "tab9.dias_plazo";
                            }
                            // Activamos contratista en RVC
                            $sql = <<<EOD
update RVC_CONTRATISTA 
    set estado = 1  
        where id_contratista = (select tab2.id_contratista
    from CO_CONTRATO_V tab0                   
    LEFT JOIN CO_CONTRATISTA  tab11 ON tab0.ID_CONTRATISTA=tab11.ID_CONTRATISTA
    LEFT JOIN RVC_CONTRATISTA tab2 ON tab11.NUM_DOC =tab2.NUM_DOC  
    where id_contrato = $id_contrato)          
EOD;
                            $this->conn->execute($sql);
                            // Actualizamos Datos ARL Contratista
                            $sql = <<<EOD
update RVC_CONTRATISTA 
    set (
  ADJUNTO_ARL,
  fecha_afilia_arl)= (select adjunto_afiliacion ,fecha_cobertura_arl 
from co_contrato_arl
where ID_CONTRATO = $id_contrato)  where id_contratista = (select tab2.id_contratista
    from CO_CONTRATO_V tab0                   
    LEFT JOIN CO_CONTRATISTA  tab11 ON tab0.ID_CONTRATISTA=tab11.ID_CONTRATISTA
    LEFT JOIN RVC_CONTRATISTA tab2 ON tab11.NUM_DOC =tab2.NUM_DOC  
    where id_contrato = $id_contrato)          
EOD;
                            $this->conn->execute($sql);
                            $tag_ent_sgr = '';
                            if ($entidadCliente == "2") {
                                $tag_ent_sgr = '.ANM.LOCAL';
                            }
                            $sql = <<<EOD
                            
INSERT INTO RVC_CONTRATO
(
  ID_CONTRATO,
  ID_CONTRATISTA,
  NUM_CONTRATO,
  ID_ANHOS,
  FECHA_CONTRATO,
  DEPENDENCIA,
  ID_AREA,
  ID_SUPERVISOR,
  ID_APOYO_SUPERVISOR,
  --FECHA_INI, 
  FECHA_FIN,
  NUMERO_PAGO,
  --ADJUNTO_POLIZA,
  VALOR_MENSUALIZADO,
  ID_TIPO_CONTRATO,
  OBJETO,
  OBLIGACIONES,
  VALOR_ANM,
  RP_ANM,
  FECHA_RP,
  CDP_ANM,
  FECHA_CDP_ANM,
  VALOR_SGR,
  RP_SGR,
  FECHA_RP_SGR,
  CDP_SGR,
  FECHA_CDP_SGR,
  FECHA_POLIZA,
  MESES_PLAZO,
  DIAS_PLAZO,
  ADJUNTO_CONTRATO,
  ID_CO_CONTRATO,
  TIPO_RECURSO,
  FECHA_INI
)
SELECT  NULL AS ID_CONTRATO,
        NVL(tab2.ID_CONTRATISTA,0) AS ID_CONTRATISTA,
        --case when tab0.fuente_financiamiento = 'NACION' then 'ANM'  || '-'||  LPAD(tab0.no_contrato,3,'0') ||'-'||tab0.id_anhos else  'SGR'  || '-'|| LPAD(tab0.no_contrato,3,'0') ||'-'||tab0.id_anhos end as NUM_CONTRATO,
        $condicionNumeroContrato as NUM_CONTRATO,                             
        tab0.ID_ANHOS,
        tab0.FECHA_CONTRATO,
      	tab7.sigla AS DEPENDENCIA,
        tab6.id_area as id_area,
        $id_supervisor,
	tab4.ID_APOYO_SUPERVISOR AS ID_APOYO_SUPERVISOR,
	--tab9.FECHA_INICIO AS FECHA_INI,
	tab9.FECHA_TERMINACION AS FECHA_FIN,
	NVL(tab0.NUMERO_PAGO,0) AS NUMERO_PAGO,
        --tab9.ADJUNTO_POLIZA AS ADJUNTO_POLIZA,
        tab0.VALOR_MENSUAL AS VALOR_MENSUALIZADO,
        tab8.id_rvc_tipo_contrato,
        to_char(dbms_lob.substr(tab0.objeto,3800,1)) as objeto,
        to_char(dbms_lob.substr(tab0.obliga_gen_contratista,3800,1)) as obligaciones,
        nvl(rpanm.valor,0) as valor_anm,
        rpanm.rp as rp_anm,
        nvl(rpanm.fecha_rp,nvl(rpsgr.fecha_rp,null)) as fecha_rp,
        rpanm.cdp as cdp_anm,
        rpanm.fecha_cdp as fecha_cdp_anm,
        nvl(rpsgr.valor,0) as valor_sgr,
        rpsgr.rp as rp_sgr,
        rpsgr.fecha_rp as fecha_sgr,
        rpsgr.cdp as cdp_sgr,
        rpsgr.fecha_cdp as fecha_cdp_sgr,
        tab9.FECHA_APRUEBA_POLIZA as FECHA_POLIZA,
        $meses_plazo as meses_plazo,
        $dias_plazo as dias_plazo,
        --'contrato_$id_contrato.pdf' as ADJUNTO_CONTRATO,
        $adjuntoContrato as ADJUNTO_CONTRATO,
        tab0.ID_CONTRATO as ID_CO_CONTRATO,
        case when rpanm.rp is not null and rpsgr.rp is not null then 2 else
            case when rpanm.rp is not null then 0 else 1 end
        end as TIPO_RECURSO,
        nvl( to_char(case 
  when rpanm.rp is not null and rpsgr.rp is null then 
    case
      when rpanm.fecha_rp > tab9.FECHA_APRUEBA_POLIZA then
        case when rpanm.fecha_rp > tab2.fecha_afilia_arl then rpanm.fecha_rp
            else tab2.fecha_afilia_arl end
      else 
        case when tab9.FECHA_APRUEBA_POLIZA > tab2.fecha_afilia_arl then tab9.FECHA_APRUEBA_POLIZA 
            else tab2.fecha_afilia_arl end
      end
  when rpanm.rp is null and rpsgr.rp is not null then 
    case
      when rpsgr.fecha_rp > tab9.FECHA_APRUEBA_POLIZA then
        case when rpsgr.fecha_rp > tab2.fecha_afilia_arl then rpsgr.fecha_rp
            else tab2.fecha_afilia_arl end
      else 
        case when tab9.FECHA_APRUEBA_POLIZA > tab2.fecha_afilia_arl then tab9.FECHA_APRUEBA_POLIZA
            else tab2.fecha_afilia_arl end
      end
  when rpanm.rp is not null and rpsgr.rp is not null then 
    case when rpanm.fecha_rp > rpsgr.fecha_rp then
      case
        when rpanm.fecha_rp > tab9.FECHA_APRUEBA_POLIZA then
          case when rpanm.fecha_rp > tab2.fecha_afilia_arl then rpanm.fecha_rp
              else tab2.fecha_afilia_arl end
        else 
          case when tab9.FECHA_APRUEBA_POLIZA > tab2.fecha_afilia_arl then tab9.FECHA_APRUEBA_POLIZA 
              else tab2.fecha_afilia_arl end
        end
    else
      case
        when rpsgr.fecha_rp > tab9.FECHA_APRUEBA_POLIZA then
          case when rpsgr.fecha_rp > tab2.fecha_afilia_arl then rpsgr.fecha_rp
              else tab2.fecha_afilia_arl end
        else 
          case when tab9.FECHA_APRUEBA_POLIZA > tab2.fecha_afilia_arl then tab9.FECHA_APRUEBA_POLIZA 
              else tab2.fecha_afilia_arl end
        end
    end
  else rpanm.fecha_rp end,'yyyy-mm-dd') , tab9.FECHA_APRUEBA_POLIZA) as fecha_ini
FROM CO_CONTRATO_V tab0                   
LEFT JOIN CO_CONTRATISTA  tab11 ON tab0.ID_CONTRATISTA=tab11.ID_CONTRATISTA
LEFT JOIN RVC_CONTRATISTA tab2 ON tab11.NUM_DOC =tab2.NUM_DOC                           
LEFT JOIN RVC_APOYO_SUPERVISOR tab4 ON tab0.APOYO_SUPERVISOR=tab4.ID_MAE_TER
JOIN CO_SELECCION_EP tab5 on tab5.ID_SELECCION_EP = tab0.ID_SELECCION_EP
JOIN CO_ESTUDIOS_PREVIOS tab6 on tab6.ID_ESTUDIOS_PREVIOS = tab5.ID_ESTUDIOS_PREVIOS
left join AREA tab7 on tab7.id_area = tab6.id_area
LEFT JOIN co_tipo_contrato tab8 on tab8.id_tipo_contrato = tab0.id_tipo_contrato
LEFT JOIN CO_APRUEBA_POLIZA tab9 on tab9.id_contrato = tab0.id_contrato
LEFT JOIN (
select tab0.* from
(select tab0.id_contrato,tab0.id_rp as rp ,rp.fecha as fecha_rp,rp.cdp as cdp,cdp.fecha as fecha_cdp ,nvl(rp.valor,0) as valor
from CO_LEGALIZA_CONTRATO tab0
left join co_contrato tab1 on tab0.ID_CONTRATO = tab1.ID_CONTRATO
left join RPS_CONTRATO_V rp on rp.rp = tab0.ID_RP and tab0.rp_sgr = rp.sgr and rp.VIGENCIA in (tab1.ID_ANHOS,tab1.ID_ANHOS+1,tab1.ID_ANHOS-1)
left join PR_CDP cdp on cdp.id = rp.cdp and rp.vigencia in (cdp.ano_fiscal,cdp.ano_fiscal+1,cdp.ano_fiscal-1)
where tab0.ID_CONTRATO=$id_contrato and tab0.rp_sgr = 0
order by nvl(rp.valor,0) DESC)tab0 where rownum = 1)rpanm on rpanm.id_contrato = tab0.id_contrato
LEFT JOIN (
select tab0.* from
(select tab0.id_contrato,tab0.id_rp as rp ,rp.fecha as fecha_rp,rp.cdp as cdp,cdp.fecha as fecha_cdp ,nvl(rp.valor,0) as valor
from CO_LEGALIZA_CONTRATO tab0
left join co_contrato tab1 on tab0.ID_CONTRATO = tab1.ID_CONTRATO
left join RPS_CONTRATO_V rp on rp.rp = tab0.ID_RP and tab0.rp_sgr = rp.sgr and rp.VIGENCIA in (tab1.ID_ANHOS,tab1.ID_ANHOS+1,tab1.ID_ANHOS-1)
left join PR_CDP@PNG_SGR$tag_ent_sgr cdp on cdp.id = rp.cdp and rp.vigencia in (cdp.ano_fiscal,cdp.ano_fiscal+1,cdp.ano_fiscal-1)
where tab0.ID_CONTRATO=$id_contrato and tab0.rp_sgr = 1
order by nvl(rp.valor,0) DESC)tab0 where rownum = 1)rpsgr on rpsgr.id_contrato = tab0.id_contrato
WHERE 1=1 AND tab0.ID_CONTRATO=$id_contrato
EOD;
                            $this->conn->execute($sql);

                            //Insertamos los RPs
                            //Obtenemos el numero de contrato
                            $sql = <<<EOD
Select 
   --case when tab0.fuente_financiamiento = 'NACION' then 'ANM'  || '-'|| LPAD(tab0.no_contrato,3,'0') ||'-'||tab0.id_anhos else  'SGR'  || '-'||  LPAD(tab0.no_contrato,3,'0') ||'-'||tab0.id_anhos end as NUM_CONTRATO
  $condicionNumeroContrato as NUM_CONTRATO                                
from CO_CONTRATO_V tab0
where tab0.ID_CONTRATO=$id_contrato
EOD;

                            $result = CN_TABLE::executeSQL($sql);
                            $num_contrato = $result[0]['num_contrato'];
                            //Obtenemos id_contrato en RVC
                            $sql = <<<EOD
Select max(id_contrato) as id_contrato
from rvc_contrato
where num_contrato = '$num_contrato'
EOD;

                            $result = CN_TABLE::executeSQL($sql);
                            $id_contrato_rvc = $result[0]['id_contrato'];

                            $sql = <<<EOD

INSERT INTO RVC_RPS_CDPS_CONTRATO
(
  ID_RPS_CDPS_CONTRATO,
  ID_CONTRATO,
  NUM_CONTRATO,
  ESTADO,
  RP,
  FECHA_RP,
  CDP,
  FECHA_CDP,
  TIPO_RECURSO,
  VALOR_RP,
  PRINCIPAL
)
(
select * 
from (select null, id_contrato,num_contrato,estado,RP_ANM as RP,FECHA_RP as FECHA_RP,CDP_ANM as CDP,FECHA_CDP_ANM as FECHA_CDP,0 as tipo_recurso,valor_anm as valor,1 as principal
from rvc_contrato
union
select null, id_contrato,num_contrato,estado,RP_SGR AS RP,nvl(FECHA_RP_SGR,FECHA_RP) as FECHA_RP,CDP_SGR as CDP,FECHA_CDP_SGR as FECHA_CDP,1 as tipo_recurso,valor_sgr as valor,1 as principal
from rvc_contrato
)
where
RP is not null and
id_contrato = ( select max(id_contrato) from rvc_contrato 
    where num_contrato in ( (SELECT cont.num_contrato FROM rvc_contrato cont 
        where cont.id_contrato = $id_contrato_rvc) ))                                        
)                                  
EOD;


                            $this->conn->execute($sql);

                            /**
                             * Se coloca la actualizacion del objeto para omitir HTML ya que en contratos si se maneja y en RVC no - 20210917
                             */
                            $sql = <<<EOD
SELECT
tab0.objeto as objeto
FROM RVC_CONTRATO tab0
where
tab0.id_contrato = $id_contrato_rvc 
EOD;

                            $result_cont_rvc = CN_TABLE::executeSQL($sql);

                            if (count($result_cont_rvc) > 0) {
                                $objeto_cont_rvc = strip_tags($result_cont_rvc[0]['objeto']);
                                //Actualiza objeto sin HTML
                                $sql = <<<EOD
update RVC_CONTRATO tab0 set tab0.objeto = '$objeto_cont_rvc'
where
tab0.id_contrato = $id_contrato_rvc                                
EOD;
                                $this->conn->execute($sql);
                            }


                            //$this->conn->commit();
                            //$logger->info("[CO_CONTRATO] commit");
                            try {
                                // Copiamos el archivo ARL a Radicacion
                                $sql = <<<EOD
select tab0.adjunto_afiliacion, tab1.adjunto_contrato,tab1.adjunto_poliza
from co_contrato_arl tab0 
LEFT JOIN CO_APRUEBA_POLIZA tab1 on tab1.id_contrato = tab0.id_contrato                                 
where tab0.ID_CONTRATO = $id_contrato
EOD;

                                $result = CN_TABLE::executeSQL($sql);
                                $adjunto_arl = $result[0]['adjunto_afiliacion'];
                                $adjunto_contrato = $result[0]['adjunto_contrato'];
                                $adjunto_poliza = $result[0]['adjunto_poliza'];
                                // copiamos archivo ARL
                                $ruta_origen = getcwd() . "/../../contratacion/web/uploads/adjunto_arl/";
                                $ruta_destino = getcwd() . "/../../../radicacionvirtualcuentasphp/web/uploads/adj_contratistas/";
                                copy($ruta_origen . $adjunto_arl, $ruta_destino . $adjunto_arl);
                                if ($service_url_new) {
                                    // Copiamos Archivo arl a servidor new
                                    $url = $service_url_new . "radicacionvirtualcuentas/file/index.json";
                                    $file_name_with_full_path = $ruta_origen . $adjunto_arl;
                                    $cFile = curl_file_create($file_name_with_full_path);
                                    $post = array('funcionalidad' => 'adj_contratistas', 'file_name' => $adjunto_arl, 'file' => $cFile);
                                    $ch = curl_init();
                                    curl_setopt($ch, CURLOPT_URL, $url);
                                    curl_setopt($ch, CURLOPT_POST, 1);
                                    curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
                                    $result = curl_exec($ch);
                                    curl_close($ch);
                                    $logger->info("[CO_CONTRATO] Peticion para enviar archivo ARL contrato: $id_contrato url: $url archivo: $adjunto_arl");
                                }
                                // Copiamos archivo contrato
                                $ruta_origen = getcwd() . "/../../contratacion/web/uploads/contrato/";
                                $ruta_destino = getcwd() . "/../../../radicacionvirtualcuentasphp/web/uploads/adj_contrato/";
                                copy($ruta_origen . $adjunto_contrato, $ruta_destino . $adjunto_contrato);
                                if ($service_url_new) {
                                    // Copiamos Archivo arl a servidor new
                                    $url = $service_url_new . "radicacionvirtualcuentas/file/index.json";
                                    $file_name_with_full_path = $ruta_origen . $adjunto_contrato;
                                    $cFile = curl_file_create($file_name_with_full_path);
                                    $post = array('funcionalidad' => 'adj_contrato', 'file_name' => $adjunto_contrato, 'file' => $cFile);
                                    $ch = curl_init();
                                    curl_setopt($ch, CURLOPT_URL, $url);
                                    curl_setopt($ch, CURLOPT_POST, 1);
                                    curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
                                    $result = curl_exec($ch);
                                    curl_close($ch);
                                    $logger->info("[CO_CONTRATO] Peticion para enviar archivo contrato contrato: $id_contrato url: $url archivo: $adjunto_contrato");
                                }
                            } catch (Exception $ex) {
                                //No se pudo copiar el archivo
                                $logger->info("[CO_CONTRATO] Error al copiar archivo Adjunto afiliacion o Contrato , id_contrato: $id_contrato");
                            }

                            /**
                             * Se actualiza numero de pagos, se tomo de la novedad de prorroga y adicion de RVC - 20230313::LAVILA
                             * Se actualiza para que tome el ultimo id contrato_rvc, ya que sino toma fechas de otros - 20230313::LAVILA
                             */
                            // Actualizar numero de pagos en la tabla co_contrato
                            $sql = <<<EOD
UPDATE CO_CONTRATO 
set  numero_pago = (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where id_contrato in (select cont.id_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato_rvc )
) 
where id_contrato = (select id_co_contrato from rvc_contrato where id_contrato = $id_contrato_rvc) 
EOD;
                            $this->conn->execute($sql);
                            // Actualizar numero de pagos en la tabla rvc_contrato
                            $sql = <<<EOD
UPDATE RVC_CONTRATO 
set  numero_pago = (
    select ceil(MONTHS_BETWEEN(last_day(max(tab0.fecha_fin)), to_date(to_char(min(tab0.fecha_ini),'YYYY-MM') || '-01','YYYY-MM-DD'))) as pagos
    from rvc_contrato tab0
    where id_contrato in (select cont.id_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato_rvc )
) 
where id_contrato =  (select max(id_contrato) from rvc_contrato 
        where num_contrato in ((select cont.num_contrato from rvc_contrato cont where cont.id_contrato = $id_contrato_rvc )))
EOD;
                            $this->conn->execute($sql);


                            // Si la entidad no es la ANM se crea automaticamente al Acta de Inicio
                            if ($entidadCliente != 2) {
                                try {
                                    //Iniciamos nueva transaccion
                                    //$this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                                    //$this->conn->beginTransaction();
                                    // Copiamos la poliza a radicacion
                                    $ruta_origen = getcwd() . "/../../contratacion/web/uploads/adjunto_poliza/";
                                    $ruta_destino = getcwd() . "/../../../radicacionvirtualcuentasphp/web/uploads/adj_contrato/";
                                    copy($ruta_origen . $adjunto_poliza, $ruta_destino . $adjunto_poliza);
                                    if ($service_url_new) {
                                        // Copiamos Archivo arl a servidor new
                                        $url = $service_url_new . "radicacionvirtualcuentas/file/index.json";
                                        $file_name_with_full_path = $ruta_origen . $adjunto_poliza;
                                        $cFile = curl_file_create($file_name_with_full_path);
                                        $post = array('funcionalidad' => 'adj_contrato', 'file_name' => $adjunto_poliza, 'file' => $cFile);
                                        $ch = curl_init();
                                        curl_setopt($ch, CURLOPT_URL, $url);
                                        curl_setopt($ch, CURLOPT_POST, 1);
                                        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
                                        $result = curl_exec($ch);
                                        curl_close($ch);
                                        $logger->info("[CO_CONTRATO] Peticion para enviar archivo poliza contrato: $id_contrato url: $url archivo: $adjunto_poliza");
                                    }
                                } catch (Exception $ex) {
                                    //No se pudo copiar el archivo
                                    $logger->info("[CO_CONTRATO] Error al copiar archivo Adjunto Poliza: $id_contrato");
                                }
                                // Actualimos la poliza en el contrato
                                $sql = <<<EOD
Update rvc_contrato set adjunto_poliza = '$adjunto_poliza' where id_contrato = $id_contrato_rvc
EOD;
                                $this->conn->execute($sql);
                                $logger->info("[CO_CONTRATO] Actualizo dato Adjunto Poliza rvc_contrato: $id_contrato_rvc");
                                // Genramos acta de inicio
                                $CODIGOTIMELOG = CN_TABLE::codigoTimeLog();
                                $nombre_reporte = "$num_contrato-Acta_inicio_$CODIGOTIMELOG.pdf";
                                $usuario_log = $request['username'];
                                $sql = <<<EOD
INSERT INTO RVC_ACTA_INICIO
      (
        FECHA_LOG ,
        USUARIO_LOG ,
        ID_ANHOS ,
        OBSERVACIONES_ESTADO ,
        DIAS_PLAZO ,
        VALOR_EJECUTADO ,
        CDP_SGR ,
        USUARIO_AUT_ACTA_INI ,
        ESTADO ,
        USUARIO_FIRMADO_ACTA_INI ,
        FECHA_CONTRATO ,
        ID_TIPO_CONTRATO ,
        NUMERO_PAGO ,
        OBLIGACIONES ,
        VALOR_MENSUALIZADO ,
        ID_CONTRATISTA ,
        FIRMADO ,
        AUTORIZADO_ACTA_INI ,
        VALOR_ANM ,
        ID_SUPERVISOR ,
        FECHA_CDP_ANM ,
        APLICA_INICIO_DIF ,
        USUARIO_ESTADO ,
        USUARIO_FIRMADO ,
        NUM_CONTRATO ,
        ADJUNTO_FIRMADO ,
        ID_AREA ,
        ID_CIUDAD ,
        ID_CONTRATO ,
        FECHA_FIRMADO_ACTA_INI ,
        ID_APOYO_SUPERVISOR ,
        RP_ANM ,
        USUARIO_AUTORIZADO ,
        FECHA_POLIZA ,
        FECHA_ESTADO ,
        CDP_ANM ,
        FECHA_FIN ,
        CARGO ,
        FECHA_RP_SGR ,
        DEPENDENCIA ,
        OBJETO ,
        VALOR_SGR ,
        ADJUNTO ,
        MESES_PLAZO ,
        FECHA_RP ,
        FECHA_CDP_SGR ,
        FECHA_AUTORIZADO_ACTA_INI ,
        ADJUNTO_POLIZA ,
        AUTORIZADO ,
        FIRMADO_ACTA_INI ,
        FECHA_AUTORIZADO ,
        FECHA_PLAZO ,
        OBSERVACION_AUT ,
        OBS_AUT_ACTA_INI ,
        FECHA_FIRMADO ,
        RP_SGR,
        FECHA_INICIO_ACTIVIDADES ,
        FECHA_INI
      )
                                        
SELECT 
  SYSDATE AS FECHA_LOG,
  --'FECHA_INICIO_ACTIVIDADES' AS FECHA_INICIO_ACTIVIDADES,
  '$usuario_log' AS USUARIO_LOG,
  tab0.ID_ANHOS AS ID_ANHOS,
  'CREACION AUTOMATICA DESDE CONTRATO' AS OBSERVACIONES_ESTADO,
  tab0.DIAS_PLAZO AS DIAS_PLAZO,
  0 as VALOR_EJECUTADO,
  tab0.CDP_SGR AS CDP_SGR,
  tab0.ID_SUPERVISOR AS USUARIO_AUT_ACTA_INI,
  1 AS ESTADO ,
  '$usuario_log' AS USUARIO_FIRMADO_ACTA_INI ,
  tab0.FECHA_CONTRATO AS FECHA_CONTRATO,
  tab0.ID_TIPO_CONTRATO AS ID_TIPO_CONTRATO,
  tab0.NUMERO_PAGO AS NUMERO_PAGO,
  tab0.OBLIGACIONES AS OBLIGACIONES,
  tab0.VALOR_MENSUALIZADO AS VALOR_MENSUALIZADO,
  tab0.ID_CONTRATISTA AS ID_CONTRATISTA,
  1 AS FIRMADO ,
  1 AS AUTORIZADO_ACTA_INI ,
  tab0.VALOR_ANM AS VALOR_ANM,
  --tab0.FECHA_INI AS FECHA_INI,
  tab0.ID_SUPERVISOR AS ID_SUPERVISOR,
  tab0.FECHA_CDP_ANM AS FECHA_CDP_ANM,
  0 AS APLICA_INICIO_DIF ,
  tab0.ID_SUPERVISOR AS USUARIO_ESTADO ,
  (select a.num_doc from rvc_contratista a where a.id_contratista = tab0.id_contratista) AS USUARIO_FIRMADO ,
  tab0.NUM_CONTRATO AS NUM_CONTRATO,
  '$nombre_reporte' AS ADJUNTO_FIRMADO ,
  tab0.ID_AREA AS ID_AREA,
  (select a.id_ciudad from rvc_contratista a where a.id_contratista = tab0.id_contratista) as ID_CIUDAD,
  tab0.ID_CONTRATO AS ID_CONTRATO ,
  sysdate AS FECHA_FIRMADO_ACTA_INI ,
  tab0.ID_APOYO_SUPERVISOR AS ID_APOYO_SUPERVISOR,
  tab0.RP_ANM as RP_ANM,
  null AS USUARIO_AUTORIZADO ,
  tab0.FECHA_POLIZA AS FECHA_POLIZA,
  sysdate as FECHA_ESTADO ,
  tab0.CDP_ANM as CDP_ANM,
  tab0.FECHA_FIN AS FECHA_FIN,
  (select a.cargo from rvc_supervisor a where a.id_supervisor = tab0.id_supervisor) AS CARGO ,
  tab0.FECHA_RP_SGR as FECHA_RP_SGR ,
  tab0.DEPENDENCIA as DEPENDENCIA ,
  tab0.OBJETO as OBJETO ,
  tab0.VALOR_SGR as VALOR_SGR ,
  null as  ADJUNTO ,
  tab0.MESES_PLAZO as MESES_PLAZO ,
  tab0.FECHA_RP as FECHA_RP ,
  tab0.FECHA_CDP_SGR as FECHA_CDP_SGR ,
  sysdate as FECHA_AUTORIZADO_ACTA_INI ,
  '$adjunto_poliza' as ADJUNTO_POLIZA ,
  0 as AUTORIZADO ,
  1 as FIRMADO_ACTA_INI ,
  null as  FECHA_AUTORIZADO ,
  tab0.FECHA_PLAZO AS FECHA_PLAZO,
  null as OBSERVACION_AUT ,
  'AUTORIZADO AUTOMATICO DESDE CONTRATACION' as OBS_AUT_ACTA_INI ,
  NULL as FECHA_FIRMADO ,
  TAB0.RP_SGR as RP_SGR,
  nvl( to_char(case 
  when tab0.tipo_recurso= 0 then 
    case
      when tab0.fecha_rp > tab0.fecha_poliza then
        case when tab0.fecha_rp > tab1.fecha_afilia_arl then tab0.fecha_rp
            else tab1.fecha_afilia_arl end
      else 
        case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
            else tab1.fecha_afilia_arl end
      end
  when tab0.tipo_recurso= 1 then 
    case
      when tab0.fecha_rp_sgr > tab0.fecha_poliza then
        case when tab0.fecha_rp_sgr > tab1.fecha_afilia_arl then tab0.fecha_rp_sgr
            else tab1.fecha_afilia_arl end
      else 
        case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
            else tab1.fecha_afilia_arl end
      end
  when tab0.tipo_recurso= 2 then 
    case when tab0.fecha_rp > tab0.fecha_rp_sgr then
      case
        when tab0.fecha_rp > tab0.fecha_poliza then
          case when tab0.fecha_rp > tab1.fecha_afilia_arl then tab0.fecha_rp
              else tab1.fecha_afilia_arl end
        else 
          case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
              else tab1.fecha_afilia_arl end
        end
    else
      case
        when tab0.fecha_rp_sgr > tab0.fecha_poliza then
          case when tab0.fecha_rp_sgr > tab1.fecha_afilia_arl then tab0.fecha_rp_sgr
              else tab1.fecha_afilia_arl end
        else 
          case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
              else tab1.fecha_afilia_arl end
        end
    end
  else tab0.fecha_rp end,'yyyy-mm-dd') , tab0.fecha_poliza) as fecha_inicio_actividades,
  nvl( to_char(case 
  when tab0.tipo_recurso= 0 then 
    case
      when tab0.fecha_rp > tab0.fecha_poliza then
        case when tab0.fecha_rp > tab1.fecha_afilia_arl then tab0.fecha_rp
            else tab1.fecha_afilia_arl end
      else 
        case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
            else tab1.fecha_afilia_arl end
      end
  when tab0.tipo_recurso= 1 then 
    case
      when tab0.fecha_rp_sgr > tab0.fecha_poliza then
        case when tab0.fecha_rp_sgr > tab1.fecha_afilia_arl then tab0.fecha_rp_sgr
            else tab1.fecha_afilia_arl end
      else 
        case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
            else tab1.fecha_afilia_arl end
      end
  when tab0.tipo_recurso= 2 then 
    case when tab0.fecha_rp > tab0.fecha_rp_sgr then
      case
        when tab0.fecha_rp > tab0.fecha_poliza then
          case when tab0.fecha_rp > tab1.fecha_afilia_arl then tab0.fecha_rp
              else tab1.fecha_afilia_arl end
        else 
          case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
              else tab1.fecha_afilia_arl end
        end
    else
      case
        when tab0.fecha_rp_sgr > tab0.fecha_poliza then
          case when tab0.fecha_rp_sgr > tab1.fecha_afilia_arl then tab0.fecha_rp_sgr
              else tab1.fecha_afilia_arl end
        else 
          case when tab0.fecha_poliza > tab1.fecha_afilia_arl then tab0.fecha_poliza 
              else tab1.fecha_afilia_arl end
        end
    end
  else tab0.fecha_rp end,'yyyy-mm-dd') , tab0.fecha_poliza) as fecha_ini
FROM RVC_CONTRATO_V tab0
join rvc_contratista tab1 on tab0.id_contratista=tab1.id_contratista
WHERE tab0.id_contrato = $id_contrato_rvc
EOD;
                                $this->conn->execute($sql);
                                $this->conn->commit();
                                $logger->info("[CO_CONTRATO] commit");
                                //Genramos Acta de Inicio
                                $sql = <<<EOD
Select * from rvc_acta_inicio where id_contrato = $id_contrato_rvc
EOD;
                                $result = CN_TABLE::executeSQL($sql);
                                $id_acta_inicio = $result[0]['id_acta_inicio'];
                                $anho_completo = $result[0]['id_anhos'];
                                //URL de envio inicio
                                $url = $url_jasper;
                                $url = $url . 'registro_acta_inicio&format=PDF&PARAM_id_mod=24&PARAM_username=websafi&PARAM_nitocc=800189921&PARAM_id_username=946';
                                $url = $url . '&PARAM_id_acta_inicio=' . $id_acta_inicio;
                                $url = $url . '&PARAM_id_anhos=' . $anho_completo;
                                $url = $url . '&PARAM_entidad_cliente=' . $entidadCliente;
                                $url = $url . '&PARAM_envio_correo=false&PARAM_tag_adjunto_modulo=true';
                                $url = $url . '&PARAM_nombre_reporte=' . str_replace(' ', ':', $nombre_reporte);

                                $this->logMessage($url);
                                $ch = curl_init($url);

                                //Parametros de retorno en cURL
                                curl_setopt($ch, CURLOPT_HEADER, 0);
                                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // Skip SSL Verification
                                //Ejecuta la petición
                                $rta = curl_exec($ch);
                                //Se cierra la conexión
                                curl_close($ch);
                            } else {
                                $this->conn->commit();
                                $logger->info("[CO_CONTRATO] commit");
                            }
                        }
                    }
                } catch (Exception $ex) {
                    $this->conn->rollback();
                    $logger->info("[CO_CONTRATO] ERROR!!! " . $ex->getMessage());
                }
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {

        //Obtenemos la entidad
        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');
        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        $config = HTMLPurifier_Config::createDefault();
        $purifier = new HTMLPurifier($config);

        /**
         * Limpiar valores - 20200129
         */
        $valor = $request['plazo'];
        $valor_limpio = $purifier->purify($valor);
        $request['plazo'] = $valor_limpio;

        $valor = $request['objeto'];
        $valor_limpio = $purifier->purify($valor);
        $request['objeto'] = $valor_limpio;

        $valor = $request['consideraciones'];
        $valor_limpio = $purifier->purify($valor);
        $request['consideraciones'] = $valor_limpio;

        $valor = $request['perfeccionamiento_ejec'];
        $valor_limpio = $purifier->purify($valor);
        $request['perfeccionamiento_ejec'] = $valor_limpio;

        $valor = $request['obliga_gen_contratista'];
        $valor_limpio = $purifier->purify($valor);
        $request['obliga_gen_contratista'] = $valor_limpio;

        $valor = $request['valor_texto'];
        $valor_limpio = $purifier->purify($valor);
        $request['valor_texto'] = $valor_limpio;

        $valor = $request['supervisor'];
        $valor_limpio = $purifier->purify($valor);
        //Para ANM y SGC guardar solo numero
        if (is_numeric($valor_limpio)) {
            $request['supervisor'] = $valor_limpio;
        } else {
            $request['supervisor'] = "";
        }


        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            // Terminacion contrato marcado para los tipo de contrato 1 y entidad SGC
            if ($entidadCliente == "1") {
                $request['terminacion'] = 1;
            }


            //20191028 Se aplica condicion para la generacion del autonumerico ya que la CEV(comision de la verdad) 
            //asignara numeros manualmente
            //Se quema mientras se establece una parametrizacion para saber si genera o no el autonumerico
            $aplica_autonumerico = 1;
            if ($entidadCliente == "8" || $entidadCliente == "2") {
                $aplica_autonumerico = 0;
            }
            //si es orden de compra es el numero que es por defecto - 20200914:LAVILA
            if (isset($request['orden_compra']) && $request['orden_compra'] == 'true') {
                $aplica_autonumerico = 0;
            }
            $logger->info("Dato aplica_autonumerico::" . $aplica_autonumerico);

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $request['id_anhos'] = $id_anhos;

            /*
             * Incidente #35673, validacion para SGC solo un consecutivo tabla co_consec_contrato - 20230524::LAVILA
             */
            if ($aplica_autonumerico == 1 && $entidadCliente == "1") {
                $sql = <<<EOD
select consecutivo from co_consec_contrato where id_anhos = $id_anhos
EOD;
                $records = CN_TABLE::executeSQL($sql);

                /*
                 * Se crea validacion para nuevo año - 20160105
                 */
                if (count($records) > 0) {

                    $consecutivo = $records[0]['consecutivo'];

                    $request['no_contrato'] = $consecutivo;

                    $sql = <<<EOD
update co_consec_contrato set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

                    CN_TABLE::executeSQL($sql);
                } else {

                    $consecutivo = 1;

                    $request['no_contrato'] = $consecutivo;

                    $sql = <<<EOD
Insert into co_consec_contrato (ID_CONSEC_CONTRATO,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;

                    CN_TABLE::executeSQL($sql);
                }
            } else {

                if ($aplica_autonumerico == 1) {
                    $id_tipo_convenio = $request['id_tipo_convenio'];

                    $carta_aceptacion = $request['carta_aceptacion'];

                    if ($carta_aceptacion == "0" || $carta_aceptacion == false || $carta_aceptacion == "false") {


                        if ($id_tipo_convenio != "") {

                            $sql = <<<EOD
select consecutivo from co_consecutivo_convenio where id_anhos = $id_anhos
EOD;
                            $records = CN_TABLE::executeSQL($sql);
                            /*
                             * Se crea validacion para nuevo año - 20170105
                             */
                            if (count($records) > 0) {

                                $consecutivo = $records[0]['consecutivo'];

                                $request['no_contrato'] = $consecutivo;

                                $sql = <<<EOD
update co_consecutivo_convenio set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

                                CN_TABLE::executeSQL($sql);
                            } else {
                                $consecutivo = 1;

                                $request['no_contrato'] = $consecutivo;

                                $sql = <<<EOD
Insert into co_consecutivo_convenio (ID_CONSECUTIVO_CONVENIO,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;

                                CN_TABLE::executeSQL($sql);
                            }
                        } else {

                            $sql = <<<EOD
select consecutivo from co_consec_contrato where id_anhos = $id_anhos
EOD;
                            $records = CN_TABLE::executeSQL($sql);

                            /*
                             * Se crea validacion para nuevo año - 20160105
                             */
                            if (count($records) > 0) {

                                $consecutivo = $records[0]['consecutivo'];

                                $request['no_contrato'] = $consecutivo;

                                $sql = <<<EOD
update co_consec_contrato set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

                                CN_TABLE::executeSQL($sql);
                            } else {

                                $consecutivo = 1;

                                $request['no_contrato'] = $consecutivo;

                                $sql = <<<EOD
Insert into co_consec_contrato (ID_CONSEC_CONTRATO,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;

                                CN_TABLE::executeSQL($sql);
                            }
                        }
                    } else {

                        $sql = <<<EOD
select consecutivo from co_consecutivo_ca where id_anhos = $id_anhos
EOD;
                        $records = CN_TABLE::executeSQL($sql);
                        /*
                         * Se crea validacion para nuevo año - 20170105
                         */
                        if (count($records) > 0) {

                            $consecutivo = $records[0]['consecutivo'];

                            $request['no_contrato'] = $consecutivo;

                            $sql = <<<EOD
update co_consecutivo_ca set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;
                        } else {
                            $consecutivo = 1;

                            $request['no_contrato'] = $consecutivo;

                            $sql = <<<EOD
Insert into co_consecutivo_ca (ID_CONSECUTIVO_CA,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;
                        }
                        CN_TABLE::executeSQL($sql);
                    }
                }
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            $logger->info("[CO_CONTRATO] id_entidad: $entidadCliente - id_tipo_contrato: " . $request['id_tipo_contrato']);
            // Terminacion contrato marcado para los tipo de contrato 1 y entidad SGC
            if ($entidadCliente == "1" && $request['id_tipo_contrato'] == "1") {
                $request['terminacion'] = 1;
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */

        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_seleccion_ep = $request['id_seleccion_ep'];
        $valor_mensual = $request['valor_mensual'];
        if ($valor_mensual <= 0) {
            $errors['mensaje'] = "El valor mensual debe ser mayor a cero(0). Favor Verificar";
            $errors['servicio'] = "co_contrato";
        }


        //verifica que se haya registrado abogado
        $sql = <<<EOD
select 
ep.id_estudios_previos,
ep.id_abogado, 
ep.valor, 
ep.id_modalidad_sel,
mo.id_tipo_proceso
from co_estudios_previos ep
join co_modalidad_sel mo on mo.id_modalidad_sel = ep.id_modalidad_sel
where ep.id_estudios_previos in (select id_estudios_previos from co_seleccion_ep where id_seleccion_ep = $id_seleccion_ep) and ep.estado = 1 
EOD;
        $records = CN_TABLE::executeSQL($sql);

        $id_estudios_previos = $records[0]['id_estudios_previos'];
        $id_abogado = $records[0]['id_abogado'];
        $valor = $records[0]['valor'];
        $id_modalidad_sel = $records[0]['id_modalidad_sel'];
        $id_tipo_proceso = $records[0]['id_tipo_proceso'];

        /**
         * Incidente #35673, cambios en validaciones(Licitación publica y selección abreviada) y solo SGC - 20230524::LAVILA
         */
        if ($entidadCliente == 1 && ($id_tipo_proceso == 21 || $id_tipo_proceso == 23)) {

            //Busca cdps para el estudio previo
            $sql = <<<EOD
        select count(*) as cantidad from co_cdps_ep
                where id_estudios_previos = $id_estudios_previos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $cdps = $records[0]['cantidad'];

            /**
             * Busca valores del estudio previo de aportes externos
             */
            $sql = <<<EOD
        select nvl(sum(valor),0) as valor from co_aporte_externo
                where id_estudios_previos = $id_estudios_previos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $total_aporte = $records[0]['valor'];


            //Si no tiene cdps y su valor es diferente a 0, no genera el cierre
            if ($cdps == 0 && $valor != 0) {

                //Si el valor de aportes externos o en especie son iguales al valor del contrato puede permitir el cierre de Estudios Previos sin CDP. - 20150909
                if ($total_aporte == $valor) {
                    
                } else {

                    $errors['mensaje'] = "No ha realizado el registro de Cdps en el EP.";
                    $errors['servicio'] = "co_contrato";
                }
            }

            $sql = <<<EOD
        select nvl(sum(valor),0) as valor from co_cdps_ep
                where id_estudios_previos = $id_estudios_previos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $total_cdp = $records[0]['valor'];

            $sql = <<<EOD
        select nvl(sum(valor),0) as valor from co_vigencia_futura
                where id_estudios_previos = $id_estudios_previos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $total_vigencias = $records[0]['valor'];


            $total = $total_cdp + $total_aporte + $total_vigencias;

            if ($total != $valor) {

                $errors['mensaje'] = "El valor registrado en CDPs del EP y Aportes no corresponde al valor Total del Proceso";
                $errors['servicio'] = "co_contrato";
            }
        }

        /*
         *  Generar errores en $errors
         */

        //Incidente #37605, validacion para guardar el contratista correctamente, ya que se evidencia error al envio, generando el salto de consecutivo de contratos - 20240212::LAVILA
        if (isset($request['id_contratista'])) {

            $id_contratista = $request['id_contratista'];

            $sql = <<<EOD
select * from co_contratista where id_contratista = $id_contratista 
EOD;
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) == 0) {
                $errors['mensaje'] = "No existe el id_contratista($id_contratista) verificar la selección del campo, refrescar pantalla y volver a probar.";
                $errors['servicio'] = "co_contrato";
            }
        }

        return $errors;
    }

    /**
     * Validacion de solo un contrato por seleccion - 20200331::LAVILA
     * 
     * @param \sfWebRequest $request
     * @return string 
     */
    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;
        $id_seleccion_ep = $request['id_seleccion_ep'];

        /*
         *  Validar la operación, ya sea por SQL
         */ $sql = <<<EOD
SELECT
    *
FROM co_contrato
where
id_seleccion_ep = $id_seleccion_ep 
and estado = 1
and activo = 1 
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "Ya existe un registro de contrato para el proceso de selección. Favor Verificar";
            $errors['servicio'] = "co_contrato";
        }

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        //Obtenemos la entidad
        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');
        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        $valor_mensual = $request['valor_mensual'];
        if ($valor_mensual <= 0) {
            $errors['mensaje'] = "El valor mensual debe ser mayor a cero(0). Favor Verificar";
            $errors['servicio'] = "co_contrato";
        }

        $id_contrato = $request['id_contrato'];
        $cerrar_contrato = $request['cerrar_contrato'];
        if ($cerrar_contrato == "true") {

            $sql = <<<EOD
        select adjunto_contrato from co_contrato tab0
                where id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $adjunto = $records[0]['adjunto_contrato'];

            $sql = <<<EOD
        select id_rp from co_legaliza_contrato tab0
                where id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {
                $id_rp = $records[0]['id_rp'];

                if ($id_rp == "") {

                    $errors['mensaje'] = "No ha realizado el registro del RP. Favor Verificar";
                    $errors['servicio'] = "co_contrato";
                }
            } else {
                $errors['mensaje'] = "No ha realizado el registro del RP. Favor Verificar";
                $errors['servicio'] = "co_contrato";
            }

            //if($entidadCliente == 2) {

            $sql = <<<EOD
            select * from co_aprueba_poliza tab0
                    where id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {
                //Correcto tiene poliza
            } else {
                $errors['mensaje'] = "No ha realizado el registro de la poliza. Favor Verificar";
                $errors['servicio'] = "co_contrato";
            }

            //Incidente #38774, validar id modalidad aplique ARL - 20240920::LAVILA
            $sql = <<<EOD
select 
tab0.id_contrato,
ep.id_modalidad_sel,
nvl((select valor from co_param_gen2 where parametro = 'MODALIDAD_SEL_ARL'),0) as ids
from co_contrato tab0
left join co_seleccion_ep sel
on tab0.id_seleccion_ep = sel.id_seleccion_ep
left join co_estudios_previos ep
on sel.id_estudios_previos = ep.id_estudios_previos
where tab0.id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);
            $id_modalidad_sel = "," . $records[0]['id_modalidad_sel'] . ",";
            $ids = "," . $records[0]['ids'] . ",";
            $pos = strpos($id_modalidad_sel, $ids);
            if ($pos !== false) {
                // Validar Registro ARL
                $sql = <<<EOD
            select * from co_contrato_arl tab0
                    where id_contrato = $id_contrato
EOD;
                $records = CN_TABLE::executeSQL($sql);
                if (count($records) > 0) {
                    //Correcto tiene ARL
                } else {
                    $errors['mensaje'] = "No ha realizado el registro de la ARL. Favor Verificar";
                    $errors['servicio'] = "co_contrato";
                }
            }
            
                
            //}

            if ($entidadCliente != 2) {

                $sql = <<<EOD
                select * from CO_AMPARO_CONT tab0
                        where id_contrato = $id_contrato
EOD;
                $records = CN_TABLE::executeSQL($sql);
                if (count($records) > 0) {
                    //Correcto tiene poliza
                } else {
                    $errors['mensaje'] = "No ha realizado el registro del amparo. Favor Verificar";
                    $errors['servicio'] = "co_contrato";
                }
            }
        } else {
            $sql = <<<EOD
            select * from co_aprueba_poliza tab0
                    where id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {
                // 20230726 se añade validacion que no permite editar el contrato si tiene registro en co_aprueba_poliza
                // al menos que se vaya a cerrar
                $errors['mensaje'] = "No se puede editar el contrato ya que tiene registro de la poliza.";
                $errors['servicio'] = "co_contrato";
            }
        }

        /*
         *  Validar la operación, ya sea por SQL
         */
        // 20220214 Si el contrato va a ser cerrado se valida contratista exista en RVC y El contrato tenga asignado tipo
        $cerrar_contrato = $request['cerrar_contrato'];
        $activo = $request['activo'];
        // SI SE VA A CERRAR
        if ($cerrar_contrato == "true" && $activo == "false") {
            // Validamos que el contrao tenga tipo asignado
            $sql = <<<EOD
            select * from co_contrato tab0
            where tab0.id_contrato = $id_contrato and tab0.id_tipo_contrato is not null 
EOD;
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {
                // Confirmamos que el tipo de contrato este relacionado en RVC para validar el contratista
                $sql = <<<EOD
Select tab1.id_rvc_tipo_contrato
from co_contrato tab0
join co_tipo_contrato tab1 on tab1.id_tipo_contrato = tab0.id_tipo_contrato
where  ID_CONTRATO=$id_contrato and  id_rvc_tipo_contrato is not null                       
EOD;
                $records = CN_TABLE::executeSQL($sql);

                if (count($records) > 0) {

                    // Bucamos el contratista en RV 
                    $sql = <<<EOD
                        select tab2.id_contratista
                        from CO_CONTRATO_V tab0                   
                        LEFT JOIN CO_CONTRATISTA  tab11 ON tab0.ID_CONTRATISTA=tab11.ID_CONTRATISTA
                        LEFT JOIN RVC_CONTRATISTA tab2 ON tab11.NUM_DOC =tab2.NUM_DOC  
                        where id_contrato = $id_contrato and tab2.id_contratista is not null
EOD;
                    $records = CN_TABLE::executeSQL($sql);

                    if (count($records) == 0) {
                        //Se actualzia mensaje enviado por chat Tatiana - 20240430::LAVILA
                        $errors['mensaje'] = "El contratista asignado al contrato, NO se encuentra actualizado en Contratación, por favor actualizar en la funcionalidad Registro de Contratistas.";
                        $errors['servicio'] = "co_contrato";
                    }
                }
            } else {
                $errors['mensaje'] = "Es necesario que el contrato tenga asignado un tipo para poder cerrarlo.";
                $errors['servicio'] = "co_contrato";
            }
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    private function htmlClear($string) {

        $string = str_replace('<p>', '<p align="justify">', $string);
        $string = str_replace('<br>', '<br/>', $string);
        $string = str_replace('class=', '', $string);
        $string = str_replace('<img', '', $string);
        $string = str_replace('<td>X</td>', '<td align="center">X</td>', $string);
        //$string = str_replace('<td align="top">', '<td align="justify">', $string);
        //$string = str_replace('<td align="justify">X</td>', '<td align="center">X</td>', $string);
        $string = str_replace('<td rowspan="2">', '<td rowspan="2" align="justify">', $string);

        $string = str_replace('<font size="2">', '<font size="10">', $string);
        $string = str_replace('<font size="3">', '<font size="12">', $string);
        $string = str_replace('<font size="4">', '<font size="14">', $string);
        $string = str_replace('<font size="5">', '<font size="18">', $string);
        $string = str_replace('<font size="6">', '<font size="24">', $string);
        $string = str_replace('<font size="7">', '<font size="36">', $string);
        $string = str_replace('<table ', '<center><table ', $string);
        $string = str_replace('</table> ', '</table></center>', $string);
        $string = str_replace('<table ', '<table border="1"', $string);

        $string = str_replace('size="2"', 'size="10"', $string);
        $string = str_replace('size="3"', 'size="12"', $string);
        $string = str_replace('size="4"', 'size="14"', $string);
        $string = str_replace('size="5"', 'size="18"', $string);
        $string = str_replace('size="6"', 'size="24"', $string);
        $string = str_replace('size="7"', 'size="36"', $string);

        $string = str_replace('border="0"', 'border="1"', $string);


        $string = str_replace('<div>', '<div align="justify">', $string);
        $string = str_replace('&amp;amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;nbsp;', '', $string);
        $string = str_replace('&amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;nbsp;', '', $string);
        $string = str_replace('<style type="text/css">P { margin-bottom: 0.08in; direction: ltr; color: rgb(0, 0, 0); line-height: 100%; text-align: justify; widows: 2; orphans: 2; }P.western { font-family: "Tahoma",sans-serif; font-size: 11pt; }P.cjk { font-family: "Times New Roman",serif; font-size: 11pt; }P.ctl { font-family: "Tahoma",sans-serif; font-size: 11pt; }A:link { color: rgb(0, 0, 255); }</style>', ' ', $string);

        $string = str_replace('<td colspan="2">', '<td colspan="2" align="justify">', $string);
        $string = str_replace('<td rowspan="3">', '<td rowspan="3" align="justify">', $string);
        $string = str_replace('<td colspan="3">', '<td colspan="3" align="justify">', $string);
        $string = str_replace('<td rowspan="4">', '<td rowspan="4" align="justify">', $string);
        $string = str_replace('<td colspan="4">', '<td colspan="4" align="justify">', $string);
        $string = str_replace('  ', ' ', $string);
        $string = str_replace('   ', ' ', $string);
        $string = str_replace('    ', ' ', $string);
        $string = str_replace('	    ', ' ', $string);
        $string = str_replace('		    ', ' ', $string);
        //$string = str_replace('<span lang="ES-TRAD">', '<span>', $string);
        $string = str_replace('<span lang="ES-COL">', '<span>', $string);
        $string = str_replace('<!-- @page { size: 21cm 29.7cm; margin: 2cm } P { margin-bottom: 0.21cm } -->', '', $string);
        $string = str_replace('<p lang="es-MX" align="justify">', '', $string);
        //$string = str_replace('<span>', '', $string);
        //$string = str_replace('</span>', '', $string); #Este es el que MAS jode :::::::::::::::::
        $string = str_replace('valign', 'align', $string);
        ;
        $string = str_replace('width=', '', $string);
        //    $string = str_replace('&nbsp;', '', $string);
        //      $string = str_replace('cellspacing=', '', $string);
        //      $string = str_replace('cellpadding=', '', $string);
        $string = str_replace('bordercolor=', '', $string);
        $string = str_replace('<td>', '<td align="justify">', $string);
        $string = str_replace('<li>', '<li align="justify">', $string);
        $string = str_replace('style=', '', $string);
        $string = str_replace('<br clear="all">', '', $string);
        return trim($string);
    }

}
